Subject: bug#77136: 31.0.50; package.el: Built-in packages marked as upgradable when versions ≤ bundled version

From: Philip Kaludercic <[email-masked]>
Date: Thu, 20 Mar 2025 16:07:52 +0000

Ship Mints <[email-masked]> writes:

> On Thu, Mar 20, 2025 at 11:46 AM <[email-masked]> wrote:
>
>> Dear Emacs maintainers,
>>
>> I've encountered an issue in `package.el` where built-in packages are
>> marked as upgradable even when the repository version is <= the built-in
>> version.  This occurs because the version comparison logic prioritizes
>> repository versions over built-in ones.
>>
>> ### Steps to reproduce:
>> 1. Set package-archive-priorities to '(("gnu" . 5) ("nongnu" . 4)).
>> 2. Set package-install-upgrade-built-in to t.
>> 3. Run `M-x list-packages` and observe the package status.
>>
>> ### Current behavior:
>> Built-in packages are marked as upgradable even when the repository
>> version is <= the built-in version.
>>
>> ### Expected behavior:
>> Built-in packages should only be marked as upgradable if the repository
>> version is newer.
>>
>> In GNU Emacs 31.0.50 (build 2, x86_64-pc-linux-gnu, GTK+ Version
>>  3.24.43, cairo version 1.18.2) of 2025-03-16 built on fedora
>> Repository revision: eab14d68b2e72b9a6b8b0cc67c9667c2bfbed4f5
>> Repository branch: master
>> System Description: Fedora Linux 41 (Workstation Edition)
>>
>> Configured using:
>>  'configure --with-imagemagick --with-pgtk --with-tree-sitter
>>  --with-mailutils --with-sound=yes --with-pdumper=yes
>>  --with-dumping=pdumper --with-file-notification=yes --with-gnutls'
>>
>> Configured features:
>> ACL CAIRO DBUS FREETYPE GIF GLIB GMP GNUTLS GPM GSETTINGS HARFBUZZ
>> IMAGEMAGICK JPEG LIBOTF LIBSELINUX LIBSYSTEMD LIBXML2 MODULES
>> NATIVE_COMP NOTIFY INOTIFY PDUMPER PGTK PNG RSVG SECCOMP SOUND SQLITE3
>> THREADS TIFF TOOLKIT_SCROLL_BARS TREE_SITTER WEBP XIM GTK3 ZLIB
>>
>> Important settings:
>>   value of $LANG: en_US.UTF-8
>>   value of $XMODIFIERS: @im=ibus
>>   locale-coding-system: utf-8-unix
>>
>> Major mode: Lisp Interaction
>>
>> Minor modes in effect:
>>   tooltip-mode: t
>>   global-eldoc-mode: t
>>   eldoc-mode: t
>>   show-paren-mode: t
>>   electric-indent-mode: t
>>   mouse-wheel-mode: t
>>   tool-bar-mode: t
>>   menu-bar-mode: t
>>   file-name-shadow-mode: t
>>   global-font-lock-mode: t
>>   font-lock-mode: t
>>   blink-cursor-mode: t
>>   minibuffer-regexp-mode: t
>>   line-number-mode: t
>>   indent-tabs-mode: t
>>   transient-mark-mode: t
>>   auto-composition-mode: t
>>   auto-encryption-mode: t
>>   auto-compression-mode: t
>>
>> Load-path shadows:
>> None found.
>>
>> Features:
>> (shadow sort mail-extr compile comint ansi-osc ansi-color ring comp-run
>> bytecomp byte-compile comp-common rx emacsbug lisp-mnt message mailcap
>> yank-media puny dired dired-loaddefs rfc822 mml mml-sec password-cache
>> epa derived epg rfc6068 epg-config gnus-util text-property-search
>> time-date subr-x mm-decode mm-bodies mm-encode mail-parse rfc2231
>> mailabbrev gmm-utils mailheader cl-loaddefs cl-lib sendmail rfc2047
>> rfc2045 ietf-drums mm-util mail-prsvr mail-utils rmc iso-transl tooltip
>> cconv eldoc paren electric uniquify ediff-hook vc-hooks lisp-float-type
>> elisp-mode mwheel term/pgtk-win pgtk-win term/common-win touch-screen
>> pgtk-dnd tool-bar dnd fontset image regexp-opt fringe tabulated-list
>> replace newcomment text-mode lisp-mode prog-mode register page tab-bar
>> menu-bar rfn-eshadow isearch easymenu timer select scroll-bar mouse
>> jit-lock font-lock syntax font-core term/tty-colors frame minibuffer
>> nadvice seq simple cl-generic indonesian philippine cham georgian
>> utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
>> japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
>> ethiopic indian cyrillic chinese composite emoji-zwj charscript charprop
>> case-table epa-hook jka-cmpr-hook help abbrev obarray oclosure
>> cl-preloaded button loaddefs theme-loaddefs faces cus-face macroexp
>> files window text-properties overlay sha1 md5 base64 format env
>> code-pages mule custom widget keymap hashtable-print-readable backquote
>> threads dbusbind inotify dynamic-setting system-font-setting
>> font-render-setting cairo gtk pgtk multi-tty move-toolbar
>> make-network-process tty-child-frames native-compile emacs)
>>
>> Memory information:
>> ((conses 16 66717 12779) (symbols 48 6838 0) (strings 32 17183 2502)
>>  (string-bytes 1 531430) (vectors 16 10577)
>>  (vector-slots 8 148392 3429) (floats 8 22 13) (intervals 56 249 0)
>>  (buffers 992 11))
>>
>
> David,
>
> See the discussion here https://debbugs.gnu.org/cgi/bugreport.cgi?bug=76567
>
> -Stephane

Adding to the previous discussion, I feel that adding
`package-install-upgrade-built-in' was a mistake and the confusion is
visible in reports like these.

My ongoing suggestion to replace `package-install-upgrade-built-in' is
to use `package-pinned-packages' and upgrade built-in packages if they
are pinned to "gnu" in the user option.  But I know that this was and is
a controversial topic, so we shouldn't deprecate anything without
putting in the necessary thought.